/* NetBSD hat kein sendfile() also mmaped oder read-write*/
/* linux ab 2.4 haben sendfile fuer >= 2.6 sendfile funktioniert nur fuer socket */
/* freebsd ab 3.0 haben sendfile */
/* solaris ab 8.0 haben sendfilev */
/* windows NT hat TransmitFile */

#include <chicken.h>

#ifdef MADV_SEQUENTIAL
#define HAVE_MADVISE 1
#else
#define HAVE_MADVISE 0
#define MADV_SEQUENTIAL 0
#endif

#ifdef __linux
 #include <sys/types.h>
 #include <unistd.h>
 #include <sys/sendfile.h>
 #include <sys/mman.h>
 #include <linux/version.h>
 #include <fcntl.h>

 double sendfile_implementation(int src,int dst,double offset,size_t to_send);

 #define HAVE_SENDFILE 1
 #define HAVE_MMAP 1
 #define USE_LINUX_IMPL
 #define _XOPEN_SOURCE 600
 #if defined(POSIX_FADV_SEQUENTIAL) && defined(POSIX_FADV_NOREUSE)
  #define HAVE_POSIX_FADVISE 
 #endif
#elif  defined(__FreeBSD__) || defined(__NetBSD__) || defined(__OpenBSD__) || defined(__DragonFly__) || defined(Macintosh) || (defined(__APPLE__) && defined(__MACH__))

 #include <sys/socket.h>
 #include <sys/types.h>
 #include <sys/mman.h>

 double sendfile_implementation(int src,int dst,double offset,size_t to_send);
 #define USE_BSD_IMPL
 #define HAVE_MMAP 1
 #if (defined(__FreeBSD__) && (__FreeBSD__ >= 3)) || defined(__DragonFly__)
  #define HAVE_SENDFILE 1
  #include <sys/uio.h>
 #else
  #define HAVE_SENDFILE 0
 #endif

#elif defined(sun) || defined(__sun)
 double sendfile_implementation(int src,int dst,double offset,size_t to_send);
 #ifdef __SunOS_5_8
   #define HAVE_SENDFILE 1
   #define HAVE_MMAP 1
   #define USE_SOLARIS_IMPL
   #include <sys/sendfile.h>
   #include <sys/mman.h>
 #else
   #define HAVE_SENDFILE 0
 #endif
#elif defined(_WIN32) || defined(_MSC_VER) || defined(__MINGW32__)
 #define HAVE_SENDFILE 0
 #define HAVE_MMAP 0
 int sendfile_implementation(int src,int dst,double offset,int to_send);
#else
 #define HAVE_SENDFILE 0
 #define HAVE_MMAP 0
 int sendfile_implementation(int src,int dst,double offset,int to_send);
#endif

